# generate genotype data for founders in predetermined pedigree

generatefdrG <- function(nfdr, alfreqforfdr, latcorrmatforfdr)
{
  nsnp <- length(alfreqforfdr)
  if ((nrow(latcorrmatforfdr) != nsnp) || (ncol(latcorrmatforfdr) != nsnp))
  {
    stop("Dimensions of the two inputs do not match!")
  }
  Z1 <- rmvnorm(nfdr, sigma = latcorrmatforfdr)
  Z2 <- rmvnorm(nfdr, sigma = latcorrmatforfdr)
  delta <- qnorm(alfreqforfdr, lower.tail = F)
  delta.mat <- matrix(rep(delta, each = nfdr), ncol = nsnp)
  G.fdr <- (Z1 > delta.mat) / 2 + (Z2 > delta.mat) / 2
  
  return(G.fdr)
}
