# generate genotype data for predetermined pedigree

generatepedG <- function(pedstr, G.fdr)
{
  fdr.ix <- which((pedstr[, 2] == 0) & (pedstr[, 3] == 0))
  if (nrow(G.fdr) != length(fdr.ix))
  {
    stop("Number of founders seems wrong!")
  }
  nind <- nrow(pedstr)
  nsnp <- ncol(G.fdr)
  G <- matrix(NA, nind, nsnp)
  G[fdr.ix, ] <- G.fdr
  
  osp.ix <- setdiff(1 : nind, fdr.ix)
  nosp <- length(osp.ix)
  for (i in 1 : nosp)
  {
    G.ospi <- rep(NA, nsnp)
    id <- osp.ix[i]
    id.fa <- pedstr[id, 2]
    id.mo <- pedstr[id, 3]
    G.ospi.fa <- G[id.fa, ]
    G.ospi.mo <- G[id.mo, ]
    ic00 <- (G.ospi.fa == 0) & (G.ospi.mo == 0)
    ic01 <- ((G.ospi.fa == 0) & (G.ospi.mo == 0.5)) | ((G.ospi.fa == 0.5) & (G.ospi.mo == 0))
    ic02 <- ((G.ospi.fa == 0) & (G.ospi.mo == 1)) | ((G.ospi.fa == 1) & (G.ospi.mo == 0))
    ic11 <- (G.ospi.fa == 0.5) & (G.ospi.mo == 0.5)
    ic12 <- ((G.ospi.fa == 0.5) & (G.ospi.mo == 1)) | ((G.ospi.fa == 1) & (G.ospi.mo == 0.5))
    ic22 <- (G.ospi.fa == 1) & (G.ospi.mo == 1)
    G.ospi[ic00] <- 0
    G.ospi[ic01] <- sample(c(0, 0.5), sum(ic01), replace = T)
    G.ospi[ic02] <- 0.5
    G.ospi[ic11] <- sample(c(0, 0.5, 0.5, 1), sum(ic11), replace = T)
    G.ospi[ic12] <- sample(c(0.5, 1), sum(ic12), replace = T)
    G.ospi[ic22] <- 1
    G[id, ] <- G.ospi
  }
  
  return(G)
}
